Index: /trunk/sources/HeuristicLab 3.3.sln
===================================================================
--- /trunk/sources/HeuristicLab 3.3.sln	(revision 2945)
+++ /trunk/sources/HeuristicLab 3.3.sln	(revision 2946)
@@ -224,4 +224,5 @@
 		{A9E282EA-180F-4233-B809-AEDF0787545C}.Release|x86.Build.0 = Release|x86
 		{BF7D9494-A586-457B-8DF9-ED599F9E6A71}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{BF7D9494-A586-457B-8DF9-ED599F9E6A71}.Debug|Any CPU.Build.0 = Debug|Any CPU
 		{BF7D9494-A586-457B-8DF9-ED599F9E6A71}.Debug|x64.ActiveCfg = Debug|x64
 		{BF7D9494-A586-457B-8DF9-ED599F9E6A71}.Debug|x64.Build.0 = Debug|x64
@@ -229,5 +230,7 @@
 		{BF7D9494-A586-457B-8DF9-ED599F9E6A71}.Debug|x86.Build.0 = Debug|x86
 		{BF7D9494-A586-457B-8DF9-ED599F9E6A71}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{BF7D9494-A586-457B-8DF9-ED599F9E6A71}.Release|Any CPU.Build.0 = Release|Any CPU
 		{BF7D9494-A586-457B-8DF9-ED599F9E6A71}.Release|x64.ActiveCfg = Release|x64
+		{BF7D9494-A586-457B-8DF9-ED599F9E6A71}.Release|x64.Build.0 = Release|x64
 		{BF7D9494-A586-457B-8DF9-ED599F9E6A71}.Release|x86.ActiveCfg = Release|x86
 		{BF7D9494-A586-457B-8DF9-ED599F9E6A71}.Release|x86.Build.0 = Release|x86
@@ -384,5 +387,6 @@
 		{B1DCDECA-B56E-41D5-9850-EF0D3A77DEAF}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{B1DCDECA-B56E-41D5-9850-EF0D3A77DEAF}.Release|Any CPU.Build.0 = Release|Any CPU
-		{B1DCDECA-B56E-41D5-9850-EF0D3A77DEAF}.Release|x64.ActiveCfg = Release|Any CPU
+		{B1DCDECA-B56E-41D5-9850-EF0D3A77DEAF}.Release|x64.ActiveCfg = Release|x64
+		{B1DCDECA-B56E-41D5-9850-EF0D3A77DEAF}.Release|x64.Build.0 = Release|x64
 		{B1DCDECA-B56E-41D5-9850-EF0D3A77DEAF}.Release|x86.ActiveCfg = Release|x86
 		{B1DCDECA-B56E-41D5-9850-EF0D3A77DEAF}.Release|x86.Build.0 = Release|x86
@@ -443,5 +447,6 @@
 		{C664305E-497C-4533-A140-967DEDB05C19}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{C664305E-497C-4533-A140-967DEDB05C19}.Release|Any CPU.Build.0 = Release|Any CPU
-		{C664305E-497C-4533-A140-967DEDB05C19}.Release|x64.ActiveCfg = Release|Any CPU
+		{C664305E-497C-4533-A140-967DEDB05C19}.Release|x64.ActiveCfg = Release|x64
+		{C664305E-497C-4533-A140-967DEDB05C19}.Release|x64.Build.0 = Release|x64
 		{C664305E-497C-4533-A140-967DEDB05C19}.Release|x86.ActiveCfg = Release|x86
 		{C664305E-497C-4533-A140-967DEDB05C19}.Release|x86.Build.0 = Release|x86
@@ -466,7 +471,8 @@
 		{E226881D-315F-423D-B419-A766FE0D8685}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{E226881D-315F-423D-B419-A766FE0D8685}.Release|Any CPU.Build.0 = Release|Any CPU
-		{E226881D-315F-423D-B419-A766FE0D8685}.Release|x64.ActiveCfg = Release|Any CPU
-		{E226881D-315F-423D-B419-A766FE0D8685}.Release|x86.ActiveCfg = Release|x64
-		{E226881D-315F-423D-B419-A766FE0D8685}.Release|x86.Build.0 = Release|x64
+		{E226881D-315F-423D-B419-A766FE0D8685}.Release|x64.ActiveCfg = Release|x64
+		{E226881D-315F-423D-B419-A766FE0D8685}.Release|x64.Build.0 = Release|x64
+		{E226881D-315F-423D-B419-A766FE0D8685}.Release|x86.ActiveCfg = Release|x86
+		{E226881D-315F-423D-B419-A766FE0D8685}.Release|x86.Build.0 = Release|x86
 		{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -477,5 +483,6 @@
 		{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}.Release|Any CPU.Build.0 = Release|Any CPU
-		{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}.Release|x64.ActiveCfg = Release|Any CPU
+		{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}.Release|x64.ActiveCfg = Release|x64
+		{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}.Release|x64.Build.0 = Release|x64
 		{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}.Release|x86.ActiveCfg = Release|x86
 		{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}.Release|x86.Build.0 = Release|x86
@@ -524,7 +531,8 @@
 		{72104A0B-90E7-42F3-9ABE-9BBBADD4B943}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{72104A0B-90E7-42F3-9ABE-9BBBADD4B943}.Release|Any CPU.Build.0 = Release|Any CPU
-		{72104A0B-90E7-42F3-9ABE-9BBBADD4B943}.Release|x64.ActiveCfg = Release|Any CPU
-		{72104A0B-90E7-42F3-9ABE-9BBBADD4B943}.Release|x86.ActiveCfg = Release|x64
-		{72104A0B-90E7-42F3-9ABE-9BBBADD4B943}.Release|x86.Build.0 = Release|x64
+		{72104A0B-90E7-42F3-9ABE-9BBBADD4B943}.Release|x64.ActiveCfg = Release|x64
+		{72104A0B-90E7-42F3-9ABE-9BBBADD4B943}.Release|x64.Build.0 = Release|x64
+		{72104A0B-90E7-42F3-9ABE-9BBBADD4B943}.Release|x86.ActiveCfg = Release|x86
+		{72104A0B-90E7-42F3-9ABE-9BBBADD4B943}.Release|x86.Build.0 = Release|x86
 		{C49CB749-8B24-4628-8003-E86475749410}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{C49CB749-8B24-4628-8003-E86475749410}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -535,7 +543,8 @@
 		{C49CB749-8B24-4628-8003-E86475749410}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{C49CB749-8B24-4628-8003-E86475749410}.Release|Any CPU.Build.0 = Release|Any CPU
-		{C49CB749-8B24-4628-8003-E86475749410}.Release|x64.ActiveCfg = Release|Any CPU
-		{C49CB749-8B24-4628-8003-E86475749410}.Release|x86.ActiveCfg = Release|x64
-		{C49CB749-8B24-4628-8003-E86475749410}.Release|x86.Build.0 = Release|x64
+		{C49CB749-8B24-4628-8003-E86475749410}.Release|x64.ActiveCfg = Release|x64
+		{C49CB749-8B24-4628-8003-E86475749410}.Release|x64.Build.0 = Release|x64
+		{C49CB749-8B24-4628-8003-E86475749410}.Release|x86.ActiveCfg = Release|x86
+		{C49CB749-8B24-4628-8003-E86475749410}.Release|x86.Build.0 = Release|x86
 		{56F9106A-079F-4C61-92F6-86A84C2D84B7}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{56F9106A-079F-4C61-92F6-86A84C2D84B7}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -546,5 +555,6 @@
 		{56F9106A-079F-4C61-92F6-86A84C2D84B7}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{56F9106A-079F-4C61-92F6-86A84C2D84B7}.Release|Any CPU.Build.0 = Release|Any CPU
-		{56F9106A-079F-4C61-92F6-86A84C2D84B7}.Release|x64.ActiveCfg = Release|Any CPU
+		{56F9106A-079F-4C61-92F6-86A84C2D84B7}.Release|x64.ActiveCfg = Release|x64
+		{56F9106A-079F-4C61-92F6-86A84C2D84B7}.Release|x64.Build.0 = Release|x64
 		{56F9106A-079F-4C61-92F6-86A84C2D84B7}.Release|x86.ActiveCfg = Release|x86
 		{56F9106A-079F-4C61-92F6-86A84C2D84B7}.Release|x86.Build.0 = Release|x86
@@ -557,5 +567,6 @@
 		{AE5B1CE5-9862-4D6F-A700-D72CD9AEA295}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{AE5B1CE5-9862-4D6F-A700-D72CD9AEA295}.Release|Any CPU.Build.0 = Release|Any CPU
-		{AE5B1CE5-9862-4D6F-A700-D72CD9AEA295}.Release|x64.ActiveCfg = Release|Any CPU
+		{AE5B1CE5-9862-4D6F-A700-D72CD9AEA295}.Release|x64.ActiveCfg = Release|x64
+		{AE5B1CE5-9862-4D6F-A700-D72CD9AEA295}.Release|x64.Build.0 = Release|x64
 		{AE5B1CE5-9862-4D6F-A700-D72CD9AEA295}.Release|x86.ActiveCfg = Release|x86
 		{AE5B1CE5-9862-4D6F-A700-D72CD9AEA295}.Release|x86.Build.0 = Release|x86
@@ -568,5 +579,6 @@
 		{96AEBBEE-4203-45F3-BCF5-7B73BF256BDA}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{96AEBBEE-4203-45F3-BCF5-7B73BF256BDA}.Release|Any CPU.Build.0 = Release|Any CPU
-		{96AEBBEE-4203-45F3-BCF5-7B73BF256BDA}.Release|x64.ActiveCfg = Release|Any CPU
+		{96AEBBEE-4203-45F3-BCF5-7B73BF256BDA}.Release|x64.ActiveCfg = Release|x64
+		{96AEBBEE-4203-45F3-BCF5-7B73BF256BDA}.Release|x64.Build.0 = Release|x64
 		{96AEBBEE-4203-45F3-BCF5-7B73BF256BDA}.Release|x86.ActiveCfg = Release|x86
 		{96AEBBEE-4203-45F3-BCF5-7B73BF256BDA}.Release|x86.Build.0 = Release|x86
@@ -579,5 +591,6 @@
 		{BB994448-2B21-4564-BB2E-38D8FFF8CF18}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{BB994448-2B21-4564-BB2E-38D8FFF8CF18}.Release|Any CPU.Build.0 = Release|Any CPU
-		{BB994448-2B21-4564-BB2E-38D8FFF8CF18}.Release|x64.ActiveCfg = Release|Any CPU
+		{BB994448-2B21-4564-BB2E-38D8FFF8CF18}.Release|x64.ActiveCfg = Release|x64
+		{BB994448-2B21-4564-BB2E-38D8FFF8CF18}.Release|x64.Build.0 = Release|x64
 		{BB994448-2B21-4564-BB2E-38D8FFF8CF18}.Release|x86.ActiveCfg = Release|x86
 		{BB994448-2B21-4564-BB2E-38D8FFF8CF18}.Release|x86.Build.0 = Release|x86
@@ -590,5 +603,6 @@
 		{57F38579-409D-4DD8-AB19-3F2C4A665126}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{57F38579-409D-4DD8-AB19-3F2C4A665126}.Release|Any CPU.Build.0 = Release|Any CPU
-		{57F38579-409D-4DD8-AB19-3F2C4A665126}.Release|x64.ActiveCfg = Release|Any CPU
+		{57F38579-409D-4DD8-AB19-3F2C4A665126}.Release|x64.ActiveCfg = Release|x64
+		{57F38579-409D-4DD8-AB19-3F2C4A665126}.Release|x64.Build.0 = Release|x64
 		{57F38579-409D-4DD8-AB19-3F2C4A665126}.Release|x86.ActiveCfg = Release|x86
 		{57F38579-409D-4DD8-AB19-3F2C4A665126}.Release|x86.Build.0 = Release|x86
@@ -625,5 +639,6 @@
 		{14AB8D24-25BC-400C-A846-4627AA945192}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{14AB8D24-25BC-400C-A846-4627AA945192}.Release|Any CPU.Build.0 = Release|Any CPU
-		{14AB8D24-25BC-400C-A846-4627AA945192}.Release|x64.ActiveCfg = Release|Any CPU
+		{14AB8D24-25BC-400C-A846-4627AA945192}.Release|x64.ActiveCfg = Release|x64
+		{14AB8D24-25BC-400C-A846-4627AA945192}.Release|x64.Build.0 = Release|x64
 		{14AB8D24-25BC-400C-A846-4627AA945192}.Release|x86.ActiveCfg = Release|x86
 		{14AB8D24-25BC-400C-A846-4627AA945192}.Release|x86.Build.0 = Release|x86
@@ -636,5 +651,6 @@
 		{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}.Release|Any CPU.Build.0 = Release|Any CPU
-		{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}.Release|x64.ActiveCfg = Release|Any CPU
+		{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}.Release|x64.ActiveCfg = Release|x64
+		{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}.Release|x64.Build.0 = Release|x64
 		{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}.Release|x86.ActiveCfg = Release|x86
 		{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}.Release|x86.Build.0 = Release|x86
@@ -659,6 +675,8 @@
 		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Release|Any CPU.Build.0 = Release|Any CPU
-		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Release|x64.ActiveCfg = Release|Any CPU
-		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Release|x86.ActiveCfg = Release|Any CPU
+		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Release|x64.ActiveCfg = Release|x64
+		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Release|x64.Build.0 = Release|x64
+		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Release|x86.ActiveCfg = Release|x86
+		{DF2E61C4-A76D-4315-9D0B-53A077B1AC2C}.Release|x86.Build.0 = Release|x86
 		{4C3305C4-E440-4EAD-B218-68D77AE51543}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{4C3305C4-E440-4EAD-B218-68D77AE51543}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -681,6 +699,8 @@
 		{F42F3576-7233-4B28-90F7-36AE15F30F92}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{F42F3576-7233-4B28-90F7-36AE15F30F92}.Release|Any CPU.Build.0 = Release|Any CPU
-		{F42F3576-7233-4B28-90F7-36AE15F30F92}.Release|x64.ActiveCfg = Release|Any CPU
-		{F42F3576-7233-4B28-90F7-36AE15F30F92}.Release|x86.ActiveCfg = Release|Any CPU
+		{F42F3576-7233-4B28-90F7-36AE15F30F92}.Release|x64.ActiveCfg = Release|x64
+		{F42F3576-7233-4B28-90F7-36AE15F30F92}.Release|x64.Build.0 = Release|x64
+		{F42F3576-7233-4B28-90F7-36AE15F30F92}.Release|x86.ActiveCfg = Release|x86
+		{F42F3576-7233-4B28-90F7-36AE15F30F92}.Release|x86.Build.0 = Release|x86
 		{35A42EE0-A896-4D7A-A99F-8ED9E925F320}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{35A42EE0-A896-4D7A-A99F-8ED9E925F320}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -691,6 +711,8 @@
 		{35A42EE0-A896-4D7A-A99F-8ED9E925F320}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{35A42EE0-A896-4D7A-A99F-8ED9E925F320}.Release|Any CPU.Build.0 = Release|Any CPU
-		{35A42EE0-A896-4D7A-A99F-8ED9E925F320}.Release|x64.ActiveCfg = Release|Any CPU
-		{35A42EE0-A896-4D7A-A99F-8ED9E925F320}.Release|x86.ActiveCfg = Release|x64
+		{35A42EE0-A896-4D7A-A99F-8ED9E925F320}.Release|x64.ActiveCfg = Release|x64
+		{35A42EE0-A896-4D7A-A99F-8ED9E925F320}.Release|x64.Build.0 = Release|x64
+		{35A42EE0-A896-4D7A-A99F-8ED9E925F320}.Release|x86.ActiveCfg = Release|x86
+		{35A42EE0-A896-4D7A-A99F-8ED9E925F320}.Release|x86.Build.0 = Release|x86
 		{887425B4-4348-49ED-A457-B7D2C26DDBF9}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{887425B4-4348-49ED-A457-B7D2C26DDBF9}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -701,6 +723,8 @@
 		{887425B4-4348-49ED-A457-B7D2C26DDBF9}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{887425B4-4348-49ED-A457-B7D2C26DDBF9}.Release|Any CPU.Build.0 = Release|Any CPU
-		{887425B4-4348-49ED-A457-B7D2C26DDBF9}.Release|x64.ActiveCfg = Release|Any CPU
-		{887425B4-4348-49ED-A457-B7D2C26DDBF9}.Release|x86.ActiveCfg = Release|Any CPU
+		{887425B4-4348-49ED-A457-B7D2C26DDBF9}.Release|x64.ActiveCfg = Release|x64
+		{887425B4-4348-49ED-A457-B7D2C26DDBF9}.Release|x64.Build.0 = Release|x64
+		{887425B4-4348-49ED-A457-B7D2C26DDBF9}.Release|x86.ActiveCfg = Release|x86
+		{887425B4-4348-49ED-A457-B7D2C26DDBF9}.Release|x86.Build.0 = Release|x86
 		{76945D76-CA61-4147-9DC2-0ACDCDDF87F9}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{76945D76-CA61-4147-9DC2-0ACDCDDF87F9}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -711,6 +735,8 @@
 		{76945D76-CA61-4147-9DC2-0ACDCDDF87F9}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{76945D76-CA61-4147-9DC2-0ACDCDDF87F9}.Release|Any CPU.Build.0 = Release|Any CPU
-		{76945D76-CA61-4147-9DC2-0ACDCDDF87F9}.Release|x64.ActiveCfg = Release|Any CPU
-		{76945D76-CA61-4147-9DC2-0ACDCDDF87F9}.Release|x86.ActiveCfg = Release|Any CPU
+		{76945D76-CA61-4147-9DC2-0ACDCDDF87F9}.Release|x64.ActiveCfg = Release|x64
+		{76945D76-CA61-4147-9DC2-0ACDCDDF87F9}.Release|x64.Build.0 = Release|x64
+		{76945D76-CA61-4147-9DC2-0ACDCDDF87F9}.Release|x86.ActiveCfg = Release|x86
+		{76945D76-CA61-4147-9DC2-0ACDCDDF87F9}.Release|x86.Build.0 = Release|x86
 		{2D4E4565-3ED9-4BEB-AE75-39D871843D24}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{2D4E4565-3ED9-4BEB-AE75-39D871843D24}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -757,6 +783,8 @@
 		{446C4F3D-1A12-465A-9128-97D0F47140C9}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{446C4F3D-1A12-465A-9128-97D0F47140C9}.Release|Any CPU.Build.0 = Release|Any CPU
-		{446C4F3D-1A12-465A-9128-97D0F47140C9}.Release|x64.ActiveCfg = Release|Any CPU
-		{446C4F3D-1A12-465A-9128-97D0F47140C9}.Release|x86.ActiveCfg = Release|Any CPU
+		{446C4F3D-1A12-465A-9128-97D0F47140C9}.Release|x64.ActiveCfg = Release|x64
+		{446C4F3D-1A12-465A-9128-97D0F47140C9}.Release|x64.Build.0 = Release|x64
+		{446C4F3D-1A12-465A-9128-97D0F47140C9}.Release|x86.ActiveCfg = Release|x86
+		{446C4F3D-1A12-465A-9128-97D0F47140C9}.Release|x86.Build.0 = Release|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution