Index: trunk/sources/HeuristicLab.Optimizer/3.3/FileManager.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/FileManager.cs	(revision 2958)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/FileManager.cs	(revision 2960)
@@ -103,5 +103,5 @@
     public static void Save() {
       IContentView activeView = MainFormManager.MainForm.ActiveView as IContentView;
-      if ((activeView != null) && (CreatableAttribute.IsCreatable(activeView.Content.GetType()))) {
+      if (activeView != null) {
         Save(activeView);
       }
@@ -120,5 +120,5 @@
     public static void SaveAs() {
       IContentView activeView = MainFormManager.MainForm.ActiveView as IContentView;
-      if ((activeView != null) && (CreatableAttribute.IsCreatable(activeView.Content.GetType()))) {
+      if (activeView != null) {
         SaveAs(activeView);
       }
@@ -156,5 +156,4 @@
       var views = from v in MainFormManager.MainForm.Views
                   where v is IContentView
-                  where CreatableAttribute.IsCreatable(((IContentView)v).Content.GetType())
                   select v as IContentView;
 
Index: trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveAllMenuItem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveAllMenuItem.cs	(revision 2958)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveAllMenuItem.cs	(revision 2960)
@@ -50,5 +50,4 @@
       var views = from v in MainFormManager.MainForm.Views
                   where v is IContentView
-                  where CreatableAttribute.IsCreatable(((IContentView)v).Content.GetType())
                   where ((v is ItemView) && ((ItemView)v).EnableFileOperations) || (!(v is ItemView))
                   select v;
Index: trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveAsMenuItem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveAsMenuItem.cs	(revision 2958)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveAsMenuItem.cs	(revision 2960)
@@ -47,5 +47,5 @@
     protected override void OnActiveViewChanged(object sender, EventArgs e) {
       IContentView activeView = MainFormManager.MainForm.ActiveView as IContentView;
-      bool enable = ((activeView != null) && (CreatableAttribute.IsCreatable(activeView.Content.GetType())));
+      bool enable = activeView != null;
       ItemView itemView = MainFormManager.MainForm.ActiveView as ItemView;
       if ((enable) && (itemView != null)) enable = itemView.EnableFileOperations;
Index: trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveMenuItem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveMenuItem.cs	(revision 2958)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/MenuItems/SaveMenuItem.cs	(revision 2960)
@@ -51,5 +51,5 @@
     protected override void OnActiveViewChanged(object sender, EventArgs e) {
       IContentView activeView = MainFormManager.MainForm.ActiveView as IContentView;
-      bool enable = ((activeView != null) && (CreatableAttribute.IsCreatable(activeView.Content.GetType())));
+      bool enable = activeView != null;
       ItemView itemView = MainFormManager.MainForm.ActiveView as ItemView;
       if ((enable) && (itemView != null)) enable = itemView.EnableFileOperations;
Index: trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/SaveAllToolBarItem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/SaveAllToolBarItem.cs	(revision 2958)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/SaveAllToolBarItem.cs	(revision 2960)
@@ -49,5 +49,4 @@
       var views = from v in MainFormManager.MainForm.Views
                   where v is IContentView
-                  where CreatableAttribute.IsCreatable(((IContentView)v).Content.GetType())
                   where ((v is ItemView) && ((ItemView)v).EnableFileOperations) || (!(v is ItemView))
                   select v;
Index: trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/SaveToolBarItem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/SaveToolBarItem.cs	(revision 2958)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/SaveToolBarItem.cs	(revision 2960)
@@ -47,5 +47,5 @@
     protected override void OnActiveViewChanged(object sender, EventArgs e) {
       IContentView activeView = MainFormManager.MainForm.ActiveView as IContentView;
-      bool enable = ((activeView != null) && (CreatableAttribute.IsCreatable(activeView.Content.GetType())));
+      bool enable = activeView != null;
       ItemView itemView = MainFormManager.MainForm.ActiveView as ItemView;
       if ((enable) && (itemView != null)) enable = itemView.EnableFileOperations;